(* Exercices et remarqued dans bourbaki *)

Require Export group.
Require Export group1.
Require Export group2.


Module Relation1.
Export Relation.

End Relation1.

Module Chapter1.


(* page 1 exemple 1 *) 
Lemma powerset_magma_union: forall (x:E),
  magma (powerset x) union2.
Proof. ir. red. red. intros a b. repeat rw powerset_inc_rw. ir.
  uf sub.  ir. pose (union2_or H1). induction o. app H. app H0.
Qed.

Lemma powerset_magma_inter: forall (x:E),
  magma (powerset x) intersection2.
Proof. ir. red. red. intros a b. repeat rw powerset_inc_rw. ir.
  uf sub. ir. app H. app (intersection2_first H1).
Qed.

(* page 1 exemple 2 *)

Definition nat_plus (x y:E):= Re ((Bnat x) + (Bnat y)).
Definition nat_mult (x y:E):= Re ((Bnat x) * (Bnat y)).
 
Lemma nat_magma_plus:   magma nat nat_plus.
Proof. red; red. ir. uf nat_plus. app R_inc. Qed.
Lemma nat_magma_mult:   magma nat nat_mult.
Proof. red; red. ir. uf nat_mult. app R_inc. Qed.

(* page 2 avant definition 2 *)
Lemma p_of_sets_is_magma: forall (x:E)(p:E2),
  magma (powerset x) (p_of_sets x p).
Proof. ir.  red. red. intros a b.  repeat rw powerset_inc_rw. ir.
  red. ir. ufi p_of_sets H1. Ztac. am.
Qed.

Lemma sub_magma_pr: forall (x:E)(p:E2)(a:E),
  magma x p -> sub a x  ->  
  sub (p_of_sets x p a a) a = magma a p.
Proof. ir. app iff_eq. ir.  red. red.  ir. app H1. app prod_of_sets_pr.
  ir.  red. ir. ufi p_of_sets H2. Ztac. nin H4. nin H4. ee. rw H6.
  app H1.
Qed.

Lemma singleton_magma: forall (x:E)(p:E2)(a:E),
  sub_magma x p (singleton a) = idempotent x p a.
Proof. ir. app iff_eq. ir.  red in H. ee.  red in H. red in H. ee. 
  assert (inc a (singleton a)). app singleton_inc. 
  red; ee. app H0.  app singleton_eq. app H.
  ir. red in H. ee. red. ee.  red. red. ir. assert (a0=a). app singleton_eq.
  assert (b=a). app singleton_eq. rw H3; rw H4; rw H0. app singleton_inc. 
  red; ir. assert (x0=a). app singleton_eq. rww H2.
Qed.

(* page 7 ex 3 *)

(* page 7, ex 3 *)

Lemma prod_law_com: forall (x:E)(p:E2),
 pcommutativity x p ->  pcommutativity (powerset x) (p_of_sets x p).
Proof. ir. assert(forall (a b:E) , inc a (powerset x) ->  inc b (powerset x)
    -> sub ((p_of_sets x p) a b) ((p_of_sets x p) b a)). 
  ir. uf sub. uf p_of_sets. ir. Ztac. clear H2. nin H4.  nin H2. ee. Ztac.
  exists x2. exists x1. ee; try am. rww H. rwi powerset_inc_rw  H1. app H1.
  rwi powerset_inc_rw  H0. app H0. 
  red. ir. red.  app extensionality. app H0. app H0.
Qed.


Definition set_of_commutants  (u:E)(p:E2)(x:E) :=
  Zo(powerset u)(fun y=> exists v, inc v x & y = commutant u p v).

Lemma set_of_commutants_pr:forall (u:E)(p:E2)(x:E)(y:E), 
  inc y x -> inc (commutant u p y) (set_of_commutants u p x).
Proof. ir. uf set_of_commutants. Ztac.
  app powerset_inc. app commutant_sub_u. exists y. intuition. 
Qed.

Lemma commutant_union: forall (u:E)(p:E2)(x:E),   nonempty x -> 
  sub (union x) u ->
  commutant u p (union x) =  intersection (set_of_commutants u p x).
Proof. ir.  assert (forall v, inc v x -> sub v u).
  ir. apply sub_trans with (union x). app union_sub. am.
  set_extens.  pose (Z_all H2). ee. clear H2. app intersection_inc.
  induction H. exists (commutant u p y). app set_of_commutants_pr.
  ir. ufi set_of_commutants H2. Ztac. nin H6. ee. rw H7. uf commutant.
  clear H2. Ztac. ir. app H4. app (union_inc (x:=x2) (y:=x1)).
  assert (inc x0 u). induction H. 
  assert (inc (commutant u p y) (set_of_commutants u p x)). 
  app set_of_commutants_pr.
  pose (intersection_forall H2 H3). app (commutant_sub_u i).
  uf commutant. Ztac.  ir. pose(union_exists H4). nin e. ee.
  assert (inc x0  (commutant u p x2)).  pose (set_of_commutants_pr u p _ _ H6). 
  app (intersection_forall H2 i). ufi commutant H7. Ztac. app H9.
Qed.



Definition LR_prod (x:E)(p:E2)(u v:E) :=
   (Zo x (fun y=> exists a, inc a x & y = p u (p a v))).

Lemma other_ident: forall (x:E)(p:E2)(h:E),
  a_magma x p -> idempotent x p h->
  identity_prop (LR_prod x p h h) p h.
Proof. ir. red in H0; ee. uf LR_prod. red. split. 
  Ztac. exists h. split. am. rw H1. rw H1. tv. 
  ir. red in H.  ee. ir. Ztac. nin H5. ee. rw H6.
  rww H2. rww H2. rww H1. app H. ir. Ztac.  nin H5. ee. rw H6. wrr H2. 
  rww H1. app H.
Qed.



End Chapter1.
