(** ** Bourbaki Sets 1 Exercices*)

Require Export set2.
Require Export set3.
Require Export set8.
Set Implicit Arguments.
(* $Id: sete4.v,v 1.1 2010/08/02 07:30:56 grimm Exp $ *)


Module Exercice5.

Definition zprod a := Zo (powerset (union a)) 
  (fun y=> forall x,  inc x a -> is_singleton (intersection2 y x)). 

Definition zprod2 a b:= zprod (doubleton a b).

Lemma zprod2_pr: forall a b y,
  inc y (zprod2 a b) =
  (sub y (union2 a b) & is_singleton (intersection2 y a) &
    is_singleton (intersection2 y b)).
Proof. ir. uf zprod2.  uf union2. uf zprod. app iff_eq. ir. Ztac. awi H0.
  split. am.  split. assert (inc a (doubleton a b)).  fprops. app H1.
  assert (inc b (doubleton a b)).  fprops. app H1.
  ir. ee. Ztac. aw. ir. nin (doubleton_or H2); ue. 
Qed.


Definition zpr x a := choose (fun z => (intersection2 x a) = singleton z).

Lemma zpr_prop : forall x a,
  is_singleton (intersection2 x a) -> (intersection2 x a = singleton (zpr x a)).
Proof. ir. uf zpr. app choose_pr.
Qed.
 
Lemma zprod2_pr1: forall a b x,
  inc x (zprod2 a b) -> 
  ((intersection2 x a = singleton (zpr x a)) &
  (intersection2 x b = singleton (zpr x b))).
Proof. ir. rwi zprod2_pr H. nin H. nin H0. ee; app zpr_prop. 
Qed.

Lemma zprod2_pr0: forall a b x,
  inc x (zprod2 a b) -> (inc  (zpr x a) a & inc (zpr x b) b).
Proof. ir. nin (zprod2_pr1 H). split.
  assert (inc (zpr x a) (intersection2 x a)). rw H0. fprops. inter2tac.
  assert (inc (zpr x b) (intersection2 x b)). rw H1. fprops. inter2tac.
Qed.

Lemma zprod2_pr00: forall a b x,
  inc x (zprod2 a b) -> (inc  (zpr x a) x & inc (zpr x b) x).
Proof. ir. nin (zprod2_pr1 H). split.
  assert (inc (zpr x a) (intersection2 x a)). rw H0. fprops. inter2tac.
  assert (inc (zpr x b) (intersection2 x b)). rw H1. fprops. inter2tac.
Qed.

Lemma zprod2_pr1a: forall a b x z,
  inc x (zprod2 a b) -> 
  inc z a -> inc z x -> z = zpr x a.
Proof. ir. nin (zprod2_pr1 H).  assert (inc z (intersection2 x a)).
  app intersection2_inc. rwi H2 H4. awi H4. am.
Qed.

Lemma zprod2_pr1b: forall a b x z,
  inc x (zprod2 a b) -> 
  inc z b -> inc z x -> z = zpr x b.
Proof. ir. nin (zprod2_pr1 H).  assert (inc z (intersection2 x b)).
  app intersection2_inc. rwi H3 H4. awi H4. am.
Qed.

Lemma zprod2_pr2: forall a b y,
  inc y (zprod2 a b) -> 
  y = doubleton (zpr y a) (zpr y b).
Proof. ir.  assert(Ha:= zprod2_pr00 H).
  nin (zprod2_pr1 H). rwi zprod2_pr H. nin H.
  set_extens. cp (H _ H3). nin (union2_or H4).  
  assert (inc x (intersection2 y a)). app intersection2_inc. 
  rwi H0 H6. awi H6. rw H6. fprops.
  assert (inc x (intersection2 y b)).
  app intersection2_inc. rwi H1 H6. awi H6. rw H6. fprops.
  nin Ha. nin (doubleton_or H3); ue. 
Qed.

Definition pair_select x p :=
  Yo (exists y, inc y p & y <> x)(choose (fun y => (inc y p & y <> x))) x.

Lemma pair_select_pr: forall x y,
  pair_select x (doubleton x y) = y.
Proof. ir. uf pair_select. 
  set (p := fun z => inc z (doubleton x y) & z <> x).
  nin (equal_or_not x y). rw Y_if_not_rw. tv. red. ir. nin H0. nin H0.
  nin (doubleton_or H0). contradiction. wri H H2. contradiction.
  assert (ex p). exists y. split. fprops. int. rww Y_if_rw.
  set (choose_pr H0). nin p0.  nin (doubleton_or H1). contradiction. am.
Qed.

Lemma zprod2_pr3: forall a b x,
  inc x (zprod2 a b) -> 
  pair_select (zpr x a) x =  (zpr x b).
Proof. ir.  set (ya := zpr x a). set (yb := zpr x b). rww (zprod2_pr2 H). 
  app  pair_select_pr.
Qed.

Lemma zprod2_pr4: forall a b x,
  inc x (zprod2 a b) ->
  pair_select (zpr x b) x =  (zpr x a).
Proof. ir.  set (ya := zpr x a). set (yb := zpr x b). rww (zprod2_pr2 H).
  rw doubleton_symm. app  pair_select_pr.
Qed.

Definition zmap f a b := sub f (zprod2 a b) & 
  (forall x, inc x (union2 a b)-> exists_unique (fun z => inc z f & inc x z)).

Definition zequivalent a b := exists f, zmap f a b.

Lemma zmap_symm: forall f a b,
  zmap f a b -> zmap f b a.
Proof. ir. uf zmap. rw union2comm. assert (zprod2 b a = zprod2 a b).
  uf zprod2. rw doubleton_symm. tv. rww H0.
Qed.

Lemma zmap_example : forall a b c d, let A := doubleton a b in
  let B := doubleton c d in
    disjoint A B -> a <> b -> c <> d ->
    zmap (doubleton (doubleton a c) (doubleton b d)) A B.
Proof. ir.  rename H into Hd. rename H0 into Hab; rename H1 into Hcd.
  red in Hd. ufi A Hd; ufi B Hd.
  assert (Hac: a <> c). int. empty_tac1 a. app intersection2_inc; fprops. ue.  
  assert (Had: a <> d). int. empty_tac1 a. app intersection2_inc; fprops. ue.  
  assert (Hbc: b <> c). int. empty_tac1 b. app intersection2_inc; fprops. ue.  
  assert (Hbd: b <> d). int. empty_tac1 b. app intersection2_inc; fprops. ue.  
  split. red. ir. rw zprod2_pr.  split.
  uf A; uf B. nin (doubleton_or H); rw H0; red; ir; nin (doubleton_or H1); 
  rw H2; try (solve [ app union2_first ; fprops ]) ; app union2_second; fprops.
  assert (Hx: forall x y z,  y <> z ->
    is_singleton (intersection2 (doubleton x y) (doubleton x z))).
  ir.  exists x0. set_extens. nin (intersection2_both H1). 
  nin (doubleton_or H2).  rw H4. fprops. 
  nin (doubleton_or H3).  rw H5. fprops.  elim H0. ue. awi H1. rw H1.
  app intersection2_inc. fprops. fprops. 

  uf A; uf B. nin (doubleton_or H); rw H0. split. app Hx. int.
  rw doubleton_symm. app Hx. split. rw (doubleton_symm a b).  app Hx. int.
  rw (doubleton_symm b d).  rw (doubleton_symm c d).  app Hx. 

  ir. ufi A H; ufi B H.
  nin (union2_or H);  nin (doubleton_or H0); rw H1; split;  
    try (solve [ exists  (doubleton a c) ; split ; fprops;  fprops]);
    try (solve [ exists  (doubleton b d) ; split ; fprops;  fprops]);
    ir; ee; nin (doubleton_or H2); nin (doubleton_or H3); rw H6; rww H7;
    try (solve [ rwi H6 H5; nin (doubleton_or H5); int; symmetry in H8; int ]);
    try (solve [ rwi H7 H4; nin (doubleton_or H4); int;  symmetry in H8; int ]).
Qed.

Lemma zmap_example_bis : forall a b c d, let A := doubleton a b in
  let B := doubleton c d in
    disjoint A B -> a <> b -> c <> d ->
    zequivalent A B.
Proof. ir. exists (doubleton (doubleton a c) (doubleton b d)).
  app (zmap_example H H0 H1).
Qed.

Lemma zmap_pr1 : forall f a b, zmap f a b ->
  union f = union2 a b.
Proof. ir. nin H. app extensionality. red. ir. nin (union_exists H1).
  nin H2. cp (H _ H3). rwi zprod2_pr H4. nin H4. app H4.
  red. ir. nin (H0 _ H1). nin H2. nin H2.  apw union_inc x0.
Qed.

Definition zmap_aux f x := choose (fun z =>  inc z f &inc x z  ).

Lemma zmap_aux_pr1: forall f a b x,
  zmap f a b -> inc x (union2 a b) ->
  (inc (zmap_aux f x) f & inc x (zmap_aux f x)).
Proof. ir. nin H. nin (H1 _ H0). uf zmap_aux. app (choose_pr H2).
Qed.

Lemma zmap_aux_pr2: forall f a b x y,
  zmap f a b -> inc x (union2 a b) -> inc y f -> inc x y
  -> y = (zmap_aux f x).
Proof. ir. cp (zmap_aux_pr1 H H0). nin H. nin (H4 _ H0). app H6. au. 
Qed.

Definition zmap_val f a x:= zpr (zmap_aux f x) a.

Lemma zmap_val_pr1 : forall f a b x, zmap f a b ->  inc x (union2 a b) -> 
  (inc (zmap_val f a x) a & inc (zmap_val f b x) b).
Proof. ir.  cp (zmap_aux_pr1 H H0). uf zmap_val. nin H. nin H1. cp (H _ H1).
  app zprod2_pr0.
Qed.

Lemma zmap_val_pr2a : forall f a b x, zmap f a b ->  inc x a ->
  (zmap_val f a x) = x.
Proof. ir. assert (inc x (union2 a b)). app union2_first.  
  nin (zmap_aux_pr1 H H1). uf zmap_val. sy. set (t := zmap_aux f x) in *.
  nin H. cp (H _ H2). ap (zprod2_pr1a H5 H0 H3).
Qed.

Lemma zmap_val_pr2b : forall f a b x, zmap f a b ->  inc x b ->
  (zmap_val f b x) = x.
Proof. ir. assert (inc x (union2 a b)). app union2_second.  
  nin (zmap_aux_pr1 H H1). uf zmap_val. sy. set (t := zmap_aux f x) in *.
  nin H. cp (H _ H2). ap (zprod2_pr1b H5 H0 H3).
Qed.

Lemma zmap_val_pr3a : forall f a b x, zmap f a b ->  inc x a ->
  (zmap_val f a (zmap_val f b x)) = x.
Proof. ir.  set (t := zmap_val f b x).  ufi zmap_val t.
  assert (inc x (union2 a b)). app union2_first. 
  nin  (zmap_aux_pr1 H H1). set (y := zmap_aux f x) in *.
  cp H. nin H. cp (H _ H2).
  cp (zprod2_pr1 H6). nin H7. assert (inc t (intersection2 y b)). rw H8.
  fprops. nin (intersection2_both H9).
  assert (inc t (union2 a b)). app union2_second. 
  cut (y = zmap_aux f t). ir.
  uf zmap_val. wr H13. sy. ap (zprod2_pr1a H6 H0 H3).
  app (zmap_aux_pr2 H4 (x:=t) (y:=y)).
Qed.

Lemma zmap_val_pr3b : forall f a b x, zmap f a b ->  inc x b ->
  (zmap_val f b (zmap_val f a x)) = x.
Proof. ir. assert (zmap f b a). app zmap_symm.  app zmap_val_pr3a.
Qed.

Lemma zmap_bijective: forall f a b, zmap f a b ->
  ( (forall x, inc x a ->  inc (zmap_val f b x) b) 
    & (forall x x', inc x a -> inc x' a ->
      (zmap_val f b x = zmap_val f b x') -> x = x')
    & (forall y, inc y b -> exists x, inc x a & (zmap_val f b x) = y)).
Proof. ir. eee. ir. assert (inc x (union2 a b)). app union2_first.
  nin (zmap_val_pr1 H H1). am. ir.
  set (f_equal (zmap_val f a) H2). rwii zmap_val_pr3a e. rwii zmap_val_pr3a e.
  ir. exists (x:= zmap_val f a y). split.
  assert (inc y (union2 a b)). app union2_second.
  nin (zmap_val_pr1 H H1). am. app  zmap_val_pr3b.

Lemma zmap_set: forall a b, exists s,
  forall f, zmap f a b = inc f s.
Proof. ir. exists (Zo (powerset (zprod2 a b)) (fun z => zmap z a b)).
  ir. app iff_eq; ir; Ztac. red in H. nin H. aw. am.
Qed.

Lemma zmap_sub: forall f a b a', zmap f a b -> sub a' a ->
  exists f', exists b', 
    (sub f' f & sub b' b & zmap f' a' b').
Proof. ir. set (f' := Zo f (fun z => inc (zpr z a) a')).
  assert (sub f' f). uf f'. app Z_sub.
  set (b':= fun_image f' (fun z => zpr z b)).
  assert (sub b' b).  uf b'. uf f'.  red. ir. awi H2. nin H2. nin H2.
  Ztac. wr H3. nin H. nin (zprod2_pr0 (H _ H4)). am.
  exists f'. exists b'. ee. am. am.
  assert (forall y, inc y f' ->  y = doubleton (zpr y a) (zpr y b)).
  ir. nin H.  set (H1 _ H3). set (H _ i). app zprod2_pr2.
  split. red. ir. cp (H3 _ H4).
  assert (inc (zpr x a) a').  ufi f' H4. Ztac. am.
  assert (inc (zpr x b) b'). uf b'.  aw. ex_tac.
  assert (inc x (zprod2 a b)). nin H. app H. app H1.
  nin (zprod2_pr1 H8).
  rw zprod2_pr. eee. red. ir. nin (doubleton_or H11); rw H12;inter2tac.  
  exists (zpr x a). set_extens. wr H9. nin (intersection2_both H11).
  app intersection2_inc. app H0. awi H11. rw H11. app intersection2_inc.
  set (t:= zpr x a). rw H5. fold t. fprops.
  exists (zpr x b). set_extens. wr H10. nin (intersection2_both H11).
  app intersection2_inc. app H2. awi H11. rw H11. app intersection2_inc.
  set (t:= zpr x b). rw H5. fold t. fprops.
  ir.  assert (inc x (union2 a b)). nin (union2_or H4). 
  app union2_first. app H0. app union2_second. app H2.
  nin (zmap_aux_pr1 H H5). split. exists (zmap_aux f x). split.
  uf f'. Ztac. change (inc (zmap_val f a x) a').
  nin (union2_or H4). cp (H0 _ H8). rww (zmap_val_pr2a H H9).
  ufi b' H8. awi H8. nin H8. nin H8. ufi f' H8. Ztac. uf zmap_val.
  cut (x0 = zmap_aux f x). ir. ue. app (zmap_aux_pr2 H (x:=x) (y:=x0)).
  wr H9. nin H. nin (zprod2_pr00 (H _ H10)). am. am.
  ir. nin H.  nin (H10 _ H5).  app H12. eee. eee.
Qed.

Lemma zequiv_symm: forall a b, zequivalent a b -> zequivalent b a.
Proof. ir. nin H. cp (zmap_symm  H). exists x. am.
Qed.


Lemma zmap_transitive: forall a b c, disjoint a c ->
  zequivalent a b -> zequivalent b c -> zequivalent a c.
Proof. intros a b c dj H H0. nin H. nin H0. rename x into f. rename x0 into g.
  set (h:= Zo (powerset (union2 a c)) 
    (fun z => exists x, exists y, inc x f & inc y g & (zpr x b = zpr y b)
      & z = doubleton (zpr x a) (zpr y c))).
  assert (forall x y, inc x f -> inc y g -> zpr x b = zpr y b ->
    inc (doubleton (zpr x a) (zpr y c)) h).
  ir. uf h. Ztac. aw. red. ir. nin H. cp (H _ H1). nin H0. cp (H0 _ H2).
  nin (zprod2_pr0 H6). nin (zprod2_pr0 H8).
  nin (doubleton_or H4); rw H13; inter2tac. exists x; exists y; eee.
  exists h. split. red. ir. rw zprod2_pr. split. ufi h H2. Ztac. awi H3; am.
  ufi h H2. Ztac. nin H4. nin H4.  nin H4. nin H5. nin H6.
  assert (x0 = doubleton (zpr x0 a) (zpr x0 b)). app zprod2_pr2. nin H. app H.
  assert (x1 = doubleton (zpr x1 b) (zpr x1 c)). app zprod2_pr2. nin H0. app H0.
  nin H. nin (zprod2_pr0 (H _ H4)). nin H0. nin (zprod2_pr0 (H0 _ H5)).
  ee. exists (zpr x0 a). rw H7. set_extens. 
  nin (intersection2_both H16). nin (doubleton_or H17). ue. rwi H19 H18.
  red in dj. empty_tac1 (zpr x1 c). app intersection2_inc. awi H16. rw H16.
  app intersection2_inc. fprops.
  exists (zpr x1 c). rw H7. set_extens. 
  nin (intersection2_both H16). nin (doubleton_or H17). ue. rwi H19 H18.
  red in dj. empty_tac1 (zpr x0 a). app intersection2_inc. ue.  awi H16.
  rw H16. app intersection2_inc. fprops.
  ir.





Qed.

End Exercice5.