Require Import ssreflect ssrbool eqtype ssrnat ssrfun.

Set Implicit Arguments.
Unset Strict Implicit.
Import Prenex Implicits.


Ltac subst1 H := move: H ; rewrite {1} addnC; move => H.
Ltac subst2 H := rewrite addnC in H.

(*

Goal ( forall a b: nat, b+a = 0 -> b+a=0).
Proof. move => a b hyp. subst1 hyp. subst2 hyp. done. Qed.
*)



Goal (exists f: Set -> nat, f nat = 0).
Proof. set (f:= fun  _:Set =>0); by exists f. Qed.


(*
Goal (exists f: Set -> nat, f nat = 0).
Proof. set f:= (fun  _:Set =>0); by exists f. Qed.

*)




Parameter ro : forall x : Set, x -> Set.
Definition inc (x y : Set) := exists a : y, ro a = x.

Axiom R_inc : forall (x : Set) (a : x), inc (ro a) x.
Axiom R_inj : forall (x : Set) (a b : x), ro a = ro b -> a = b.

Parameters F G: Set.
Parameter W: Set -> Set -> Set.
Parameter f: G->F.

Theorem exists_left_composable: 
  (forall x, ro (f x) = W (ro x) F) ->
  (forall x y, inc x G -> inc y G -> 
    W x G = W y G -> W x F = W y F) ->
  (forall x: G, W (ro x) G = nat) -> 
  (forall x y : G, f x = f y).

Proof. 
move=> H1 H2 H3 x y.
apply R_inj.  
rewrite  2! H1.
apply H2; try apply: R_inc;  rewrite  H3//.

(* proof ok *)   
Qed.
Print exists_left_composable.


Parameter im : forall x : Set, (x -> Set) -> Set.

Axiom IM_exists :
          forall (x : Set) (f : x -> Set) (y : Set),
          inc y (im f) -> exists a : x, f a = y.

CoInductive Zorec (x : Set) (f : x -> Prop) : Set :=
  Zorec_c :forall (a: x), f a -> Zorec f.



Definition Zo (x:Set) (p:Set -> Prop) :=
  im (fun  (z : Zorec (fun (a : x) => p (ro a))) => let (a, _) := z in ro a).

(* bug connu

Lemma Z_rw: forall  x p y, inc y (Zo x p) -> (inc y x /\ p y).
Proof.
move=> x y p H; elim:  (IM_exists H) => v Hv.
Abort.

*)


Require Export sset2.

Check bcreate.


Parameters F G: Set.
Parameter W: Set -> Set -> Set.
Parameter f: G->F.

Theorem exists_left_composable: 
  (forall x, Ro (f x) = W (Ro x) F) ->
  (forall x y, inc x G -> inc y G -> 
    W x G = W y G -> W x F = W y F) ->
  (forall x: G, W (Ro x) G = nat) -> 
  (forall x y : G, f x = f y).

Proof. 
move=> H1 H2 H3 x y.
apply R_inj.  
rewrite  2! H1.
apply H2; try apply R_inc;  rewrite  H3//.   
Qed.


move=> [h ch]. 
exists  (acreate h); split; first by hnf; intuition; aw. 
have: (acreate (h \o (bcreate1 fg)) = acreate bf) by apply acreate_exten.
by rewrite -compose_acreate  (bcreate_inv1 fg) bcreate_inv2.  
Qed.


Theorem exists_left_composable: forall f g
  (ff:is_function f) (fg:is_function  g) (sfsg:source f = source g),
  
  (forall x y, inc x (source g) -> inc y (source g) -> 
    W x g = W y g -> W x f = W y f) ->
(exists h : target g -> (target f),  h \o (bcreate1 fg) =1 
(bcreate ff sfsg (refl_equal (target f)))).
Proof. 
move=> f g ff fg sfsg.
have sg: surjective g. admit.
move: (bcreate1_surjective fg sg) => scb.
 rewrite (exists_left_composableC _ scb).
  move =>x y sv; apply R_inj; do 2 rewrite prop_bcreate2. 
  by apply hyp; try apply: R_inc;  rewrite  -2!  (prop_bcreate1 fg) sv.
admit. Qed.
set (bf:=bcreate ff sfsg (refl_equal (target f))).
move=> hyp.
have:(exists h : target g -> (target f),  h \o (bcreate1 fg) =1 bf).
  rewrite (exists_left_composableC bf scb).
  move =>x y sv; apply R_inj; do 2 rewrite prop_bcreate2. 
  by apply hyp; try apply: R_inc;  rewrite  -2!  (prop_bcreate1 fg) sv.
admit. Qed.
move=> [h ch]. 
exists  (acreate h); split; first by hnf; intuition; aw. 
have: (acreate (h \o (bcreate1 fg)) = acreate bf) by apply acreate_exten.
by rewrite -compose_acreate  (bcreate_inv1 fg) bcreate_inv2.  
Qed.

Lemma exists_left_composable_auxC: forall (a b c:Set) (f:a->b) (g:a-> c) s h,
   is_right_inverseC s g ->
  h \o g =1 f -> h =1 f \o s.
Proof. 
move=> a b c f g s h  ri eq x /=; rewrite -eq /=. 
by move: (ri  x) => /=  ->.
Qed.

Theorem exists_left_composable_aux: forall f g s h ,
  is_function f -> source f = source g ->
  is_right_inverse s g ->
  composable  h g -> compose h g = f -> h = compose f s.
Proof. 
move=> f g s h gg sfsg [csg cshi]  chg  <-. 
have shtg:(source h= target g) by move: chg=> [_ [_]].
by rewrite compose_assoc // cshi -shtg compose_id_right //; fct_tac. 
Qed.

Lemma exists_unique_left_composableC: forall (a b c:Set) (f:a->b)(g:a->c) h h',
  surjectiveC g -> h \o g =1 f -> h' \o g =1 f ->  h =1 h'.
Proof. 
move=> a b c f g h h' sg chg chg' x.
move: (exists_right_inv_from_surjC sg) => [j jp].
rewrite (exists_left_composable_auxC jp chg).
by rewrite (exists_left_composable_auxC jp chg').
Qed.

Theorem exists_unique_left_composable: forall f g h h',
  is_function f -> surjective g -> source f = source g ->
  composable  h g -> compose h g = f -> 
  composable  h' g -> compose h' g = f -> h = h'.
Proof.
move=>f g h h' ff sg sfsg chg chgf chg' chgf'.
move:(exists_right_inv_from_surj sg)=> [j jp].
rewrite (exists_left_composable_aux ff sfsg jp chg chgf).
by rewrite (exists_left_composable_aux ff sfsg jp chg' chgf').
Qed.



Require Export sset3.
Require Export sset4.

Theorem exists_left_composable: forall f g,
  is_function f -> surjective g -> source f = source g ->
  (forall x y, inc x (source g) -> inc y (source g) -> 
   W x g = W y g -> W x f = W y f) ->
    (exists h, composable  h g & compose h g = f).

Proof. 
move=> f g ff sg sfsg.
have fg: is_function g by fct_tac.
move: (bcreate1_surjective fg sg) => scb.
set (bf:=bcreate ff sfsg (refl_equal (target f))).
move=> hyp.
have:(exists h : target g -> (target f),  h \o (bcreate1 fg) =1 bf).
  rewrite (exists_left_composableC bf scb).
  move =>x y sv; apply R_inj; do 2 rewrite prop_bcreate2. 
  by apply hyp; try apply R_inc;  rewrite  -2!  (prop_bcreate1 fg) sv.
move=> [h ch]. 
exists  (acreate h); split; first by hnf; intuition; aw. 
have: (acreate (h \o (bcreate1 fg)) = acreate bf) by apply acreate_exten.
by rewrite -compose_acreate  (bcreate_inv1 fg) bcreate_inv2.  
Qed.



Parameter ro : forall x : Set, x -> Set.
Parameter im : forall x : Set, (x -> Set) -> Set.

Axiom IM_exists :
          forall (x : Set) (f : x -> Set) (y : Set),
          inc y (im f) -> exists a : x, f a = y.

CoInductive Zorec (x : Set) (f : x -> Prop) : Set :=
  Zorec_c :forall (a: x), f a -> Zorec f.



Definition Zo (x:Set) (p:Set -> Prop) :=
  im (fun  (z : Zorec (fun (a : x) => p (ro a))) => let (a, _) := z in ro a).


Lemma Z_rw: forall  x p y, inc y (Zo x p) -> (inc y x & p y).
Proof.
move=> x y p H; elim:  (IM_exists H) => v Hv.
Abort.

*)

